create schema mytest;
set schema mytest;

create library qa_udf_lib file '<mydir>/myudf.so';

create function qa_udf_clob
(INVAL clob)
returns (c_clob clob)
language c
parameter style sql
external name 'qa_func_vcstruct'
library qa_udf_lib
deterministic
state area size 1024
allow any parallelism
no sql;

create function qa_udf_blob
(INVAL blob)
returns (c_blob blob)
language c
parameter style sql
external name 'qa_func_vcstruct'
library qa_udf_lib
deterministic
state area size 1024
allow any parallelism
no sql;

create function qa_udf_clob_mvf
(INVAL clob)
returns (c_clob1 clob, c_clob2 clob)
language c
parameter style sql
external name 'qa_func_vcstruct_mvf'
library qa_udf_lib
deterministic
state area size 1024
allow any parallelism
no sql;

create function qa_udf_blob_mvf
(INVAL blob)
returns (c_blob1 blob, c_blob2 blob)
language c
parameter style sql
external name 'qa_func_vcstruct_mvf'
library qa_udf_lib
deterministic
state area size 1024
allow any parallelism
no sql;

create table mytable (c_clob clob, c_blob blob);
insert into mytable values ('CLOB_1', 'BLOB_1');

select 
cast(qa_udf_clob(c_clob) as char(10)),
cast(qa_udf_blob(c_blob) as char(10))
from mytable;

select qa_udf_clob_mvf(c_clob) from mytable; 
select qa_udf_blob_mvf(c_blob) from mytable;

drop table mytable cascade;
drop function qa_udf_clob cascade;
drop function qa_udf_blob cascade;
drop function qa_udf_clob_mvf cascade;
drop function qa_udf_blob_mvf cascade;
drop library qa_udf_lib cascade;
drop schema mytest cascade;

